<template>
    <div class="box__pc--element">
        <h2 class="bold-title">{{ currency.name }}</h2>
        <p class="text-podTitle" style="color: #2e64e4">{{ rate }}</p>
        <p class="valuta">{{ currency.code_iso }}</p>
        <div class="box-icon">
            <router-link :to="route('currencies_edit', {id: currency.id})">
                <svg class="edit">
                    <use xlink:href="/img/sprite.svg#edit"/>
                </svg>
            </router-link>
            <a href="#" @click.prevent="deleteCurrency">
                <svg class="delete">
                    <use xlink:href="/img/sprite.svg#cancel-button"/>
                </svg>
            </a>
            <a href="#" @click.prevent="updateRate">
                <svg class="update-rate" :class="{'spin-animate': is_updating}">
                    <use xlink:href="/img/sprite.svg#cycle-couple-of-arrows-hand-drawn-lines"/>
                </svg>
            </a>
        </div>
    </div>
</template>

<script>
    import {mapGetters} from 'vuex';
    import route from "../../mixins/route";
    import currencies from "../../currencies";

    const accounting = require('accounting');

    export default {
		name: "Currency",
        props: ['currency', 'is_all_updating'],
        mixins: [route],
        data(){
		    return {
		        is_updating: this.is_all_updating,
            }
        },
        watch: {
            is_all_updating(val){
                this.is_updating = val;
            }
        },
        computed: {
		    ...mapGetters([
		        'axios'
            ]),
		    rate(){
		        const rate = currencies.rateById(this.currency.id);
                return accounting.formatMoney(rate, '', this.currency.format_precision, ' ');
            }
        },
        methods: {
            deleteCurrency(){
                this.axios
                    .post(`currencies/${this.currency.id}/delete`)
                    .then(resp => resp.data)
                    .then(data => {
                        this.$swal(this.$t('ui.success'), data.message, 'success');
                        this.$emit('deleted', this.currency.id)
                    });
            },
            updateRate(){
                this.is_updating = true;
                this.$emit('updating', true);
                this.axios
                    .get(`currencies/${this.currency.id}/update_rate`)
                    .then(resp => resp.data)
                    .then(data => {
                        this.$swal('Успешно', 'Курс обновлен', 'success');
                        this.$emit('updated-rate', data.currency);
                    })
                    .finally(() => {
                        this.is_updating = false;
                        this.$emit('updating', false);
                    })
                ;
            },
        }

	}
</script>

<style scoped>
    .update-rate{
        width: 20px;
        height: 20px;
        fill: #3069e9;
        margin-left: 25px;
    }

    /*noinspection CssUnusedSymbol*/
    .spin-animate{
        animation-name: spin;
        animation-duration: 1000ms;
        animation-iteration-count: infinite;
        animation-timing-function: linear;
    }
    @keyframes spin {
        from {
            transform:rotate(0deg);
        }
        to {
            transform:rotate(360deg);
        }
    }
</style>
